Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait MatchTreeMaking extends MatchCodeGen with Debugging

  Translate our IR (TreeMakers) into actual Scala Trees using the factory methods in MatchCodeGen.

  Translate our IR (TreeMakers) into actual Scala Trees using the factory methods in MatchCodeGen.

  The IR is mostly concerned with sequencing, substitution, and rendering all necessary conditions, mostly agnostic to whether we're in optimized/pure (virtualized) mode.

  Definition Classes
    patmat
-  trait TreeMakers extends TypedSubstitution with CodegenCore
  Definition Classes
    MatchTreeMaking
- AbsCodegen
- AlternativesTreeMaker
- BodyTreeMaker
- Casegen
- CommonCodegen
- CondTreeMaker
- EmptySubstitution
- EqualityTestTreeMaker
- ExtractorTreeMaker
- FunTreeMaker
- GuardTreeMaker
- IrrefutableExtractorTreeMaker
- NoNewBinders
- NonNullTestTreeMaker
- PreserveSubPatBinders
- ProductExtractorTreeMaker
- SubstOnlyTreeMaker
- Substitution
- TreeMaker
- TrivialTreeMaker
- TypeTestTreeMaker

c

scala.tools.nsc.transform.patmat.MatchTreeMaking.TreeMakers

# TreeMaker

###

#### abstract class TreeMaker extends AnyRef

Source
  MatchTreeMaking.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
ReusedCondTreeMaker, ReusingCondTreeMaker, AlternativesTreeMaker, BodyTreeMaker, CondTreeMaker, EqualityTestTreeMaker, ExtractorTreeMaker, FunTreeMaker, GuardTreeMaker, NoNewBinders, NonNullTestTreeMaker, PreserveSubPatBinders, ProductExtractorTreeMaker, SubstOnlyTreeMaker, TrivialTreeMaker, TypeTestTreeMaker
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TreeMaker
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new TreeMaker()

### Abstract Value Members

1.  abstract def chainBefore(next: Global.Tree)(casegen: TreeMakers.Casegen): Global.Tree
2.  abstract def localSubstitution: TreeMakers.Substitution
   Attributes
     protected
3.  abstract def pos: Global.Position

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from TreeMaker toany2stringadd[TreeMaker] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (TreeMaker, B)
   Implicit
     This member is added by an implicit conversion from TreeMaker toArrowAssoc[TreeMaker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def ensuring(cond: (TreeMaker) => Boolean, msg: => Any): TreeMaker
   Implicit
     This member is added by an implicit conversion from TreeMaker toEnsuring[TreeMaker] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (TreeMaker) => Boolean): TreeMaker
   Implicit
     This member is added by an implicit conversion from TreeMaker toEnsuring[TreeMaker] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: => Any): TreeMaker
    Implicit
      This member is added by an implicit conversion from TreeMaker toEnsuring[TreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): TreeMaker
    Implicit
      This member is added by an implicit conversion from TreeMaker toEnsuring[TreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from TreeMaker toStringFormat[TreeMaker] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
22.  def subPatternsAsSubstitution: TreeMakers.Substitution

    The substitution that specifies the trees that compute the values of the subpattern binders.

    The substitution that specifies the trees that compute the values of the subpattern binders.

    Should not be used to perform actual substitution! Only used to reason symbolically about the values the subpattern binders are bound to. See TreeMakerToCond#updateSubstitution.

    Overridden in PreserveSubPatBinders to pretend it replaces the subpattern binders by subpattern refs (Even though we don't do so anymore -- see scala/bug#5158, scala/bug#5739 and scala/bug#6070.)

    TODO: clean this up, would be nicer to have some higher-level way to compute the binders bound by this tree maker and the symbolic values that correspond to them

23.  def substitution: TreeMakers.Substitution

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

24.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
25.  def toString(): String
    Definition Classes
      AnyRef → Any
26.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
27.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
28.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (TreeMaker, B)
   Implicit
     This member is added by an implicit conversion from TreeMaker toArrowAssoc[TreeMaker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromTreeMaker to any2stringadd[TreeMaker]

### Inherited by implicit conversion StringFormat fromTreeMaker to StringFormat[TreeMaker]

### Inherited by implicit conversion Ensuring fromTreeMaker to Ensuring[TreeMaker]

### Inherited by implicit conversion ArrowAssoc fromTreeMaker to ArrowAssoc[TreeMaker]

### Ungrouped